#!/bin/sh

echo "Content-type: text/html"
echo
echo "<html><body><h2>start internet connection</h2><pre>"

Provider=`echo $QUERY_STRING | /usr/bin/gawk -F '=' '{print $2}'`

if [ -z "$Provider" ]
then
  echo "No provider selected..."
  echo "</pre><BR><BR><form>"
  echo "<input type=button value=\"Ok\" onClick=\"history.back()\">"
  echo "</form></body></html>"
  exit 1
fi

PIDFILE=/var/run/ppp0.pid
PIDFILE2=/var/run/ppp0.pid

PIDS=`ps h -C pppd | gawk '{print $1}'`
if [ ! -z "$PIDS" ]
then
  #pppd is running
  DEVICE=`cat /proc/net/dev | grep ppp0 | gawk -F ':' '{print$1}'` > /dev/null 2>&1
  IP=`/usr/bin/sudo /sbin/ifconfig $DEVICE | grep "inet addr" | gawk '{print $2}' | gawk -F ':' '{print $2}'`
  if [ "$IP" == "192.168.0.1" ]
  then
    sudo /bin/kill $PIDS
    sleep 1
    ps h -C pppd | gawk '{print $1}'
    i=$?
    while [ $i -eq 0 ]
    do
      sleep 1
      ps h -C pppd | gawk '{print $1}'
      i=$?
    done
    echo "connecting to $Provider..."
    sudo /sbin/pppd connect /bin/true call isdn/$Provider
  else
    echo "1st channel is already online..."
  fi
else
  sudo /bin/kill $PIDS

  sleep 1
  ps h -C pppd | gawk '{print $1}'
  i=$?
  while [ $i -eq 0 ]
  do
    sleep 1
    ps h -C pppd | gawk '{print $1}'
    i=$?
  done
  echo "connecting to $Provider..."
  sudo /sbin/pppd connect /bin/true call isdn/$Provider
fi

echo "</pre><BR><BR><form>"
echo "<input type=button value=\"Ok\" onClick=\"history.back()\">"
echo "</form></body></html>"
exit 0