#!/bin/sh

echo "Content-type: text/html"
echo

echo "1st channel: "

PIDS=`ps -C ipppd | gawk '{print $1}'`
if [ ! -z "$PIDS" ]
then
   #pppd is running
   DEVICE=`cat /proc/net/dev | gawk -F ':' '{print$1}' | grep ppp0` > /dev/null 2>&1
   if [ $? -ne 0 ]
   then
     echo "offline<br>2nd channel: offline"
     exit 1
   fi
   IP=`sudo /sbin/ifconfig $DEVICE | grep "inet addr" | gawk '{print $2}' | gawk -F ':' '{print $2}'`
   if [ "$IP" == "192.168.0.1" ]
   then
     echo "offline<br>2nd channel: offline"
     exit 2
   fi
   echo "$IP<br>2nd channel: "
   DEVICE=`cat /proc/net/dev | gawk -F ':' '{print$1}' | grep ppp1` > /dev/null 2>&1
   if [ $? -ne 0 ]
   then
     echo "offline"
     exit 3
   fi
   IP=`sudo /sbin/ifconfig $DEVICE | grep "inet addr" | gawk '{print $2}' | gawk -F ':' '{print $2}'`
   if [ "$IP" == "192.168.0.1" ]
   then
     echo "offline"
     exit 4
   fi
   echo "$IP"
else
   echo "offline<br>2nd channel: offline"
fi

exit 0